#include "../Headers/UART.h"

void UARTInit( unsigned int ubrr)
{
    /* Baud rate settings */
    UBRRH = (unsigned char)(ubrr>>8);
    UBRRL = (unsigned char)ubrr;
    /* Enabling transmitter and receiver */
    UCSRB = (1<<RXEN)|(1<<TXEN)|(1<<RXC);
    /* Frame format settings: 8data, 2stop bit */
    UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
}


void UARTPutchar(char c, FILE *stream) {
    /* If a line feed character is received, then a \r must be inserted
     * in order to make it windows compatible */
    if( c == '\n')
    {
        loop_until_bit_is_set(UCSRA, UDRE);
        UDR = '\r';
    }
    
    loop_until_bit_is_set(UCSRA, UDRE);
    UDR = c;
}

char UARTGetchar(FILE *stream) {
    loop_until_bit_is_set(UCSRA, RXC); /* We are waiting, for data to receive. */
    return UDR;
}